#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


DL=`dumpsys battery | grep "status: 2"`

ykj() {
    # uptime
    awk -F '.' '{run_days=$1 / 86400;run_hour=($1 % 86400)/3600;run_minute=($1 % 3600)/60;run_second=$1 % 60;printf("%d天%d时%d分%d秒",run_days,run_hour,run_minute,run_second)}' /proc/uptime
}

bd() {
    local a
    a=`getprop ro.build.version.security_patch`
    [[ -z $a ]] && a=`getprop ro.vendor.build.security_patch`
    echo "$a"
}

rt() {
    echo "已ROOT"
    echo
    echo "su文件：`which -a su`"
}

ab() {
    . $SCRIPT/switch_ab_partition.sh -c &>/dev/null
    [[ $? -eq 0 ]] && echo "是，当前槽位：$SLOT" || echo "否"
}

bb() {
    (
    PATH="$PATH0"
    which -a busybox
    [[ $? -ne 0 ]] && echo "未找到"
    )
}

tb() {
    (
    PATH="$PATH0"
    which -a toybox
    [[ $? -ne 0 ]] && echo "未找到"
    )
}

fingerprint() {
    a=`getprop ro.build.fingerprint`
    if [[ -n "$a" ]]; then
        echo "$a"
    else
        echo "不支持指纹"
    fi
}

sl() {
    case `getenforce` in
        Enforcing)
            echo "开启（Enforcing）"
        ;;
        
        Permissive)
            echo "关闭（Permissive）"
        ;;
        
        Disabled)
            echo "禁用(Disabled)"
        ;;
        
        *)
            echo "未知：`getenforce`"
        ;;
    esac
}

gp() {
    $by_name | egrep -q -m 1 "/$1\>"
    return $?
}

fqjg() {
    if gp super; then
        if gp vendor_boot_[ab] && gp system_ext_[ab]; then
            echo "Virtual-A/B动态分区"
        elif gp system_[ab] && gp vendor_[ab]; then
            echo "A/B动态分区"
        else
            echo "OnlyA动态分区"
        fi
    elif gp system_[ab] && gp vendor_[ab] && gp boot_[ab]; then
        echo "A/B分区"
    else
        echo "OnlyA分区"
    fi
}

super() {
    if gp super; then
        echo "有"
    else
        echo "无"
    fi

}

marketname() {
    local a
    a=`getprop ro.product.marketname` #红米
    if [[ -z $a ]]; then a=`getprop ro.display.series` #一加
    if [[ -z $a ]]; then a=`getprop ro.oppo.market.name` #OPPO realme
    if [[ -z $a ]]; then a=`getprop ro.config.marketing_name` #荣耀
    if [[ -z $a ]]; then a=`getprop net.hostname`
    if [[ -z $a ]]; then a="未知"
    fi
    fi
    fi
    fi
    fi
    echo "$a"
}

rom_type() {
    if [[ `find /dev/block/ -maxdepth 1 -type b -iname "mmcblk0*" | wc -l` -ne 0 ]]; then
        echo "eMMC"
    elif [[ `find /dev/block/ -maxdepth 1 -type b -iname "sda*" | wc -l` -ne 0 ]]; then
        echo "UFS"
    fi
}



echo "
当前手机型号：`getprop ro.product.model`

销售型号：`marketname`

品牌：`getprop ro.product.brand`

设备代号：`getprop ro.product.device`

安卓版本：`getprop ro.build.version.release`

安卓SDK：$SDK

ROM版本号：`getprop ro.build.version.incremental`

ROM编译日期：`getprop ro.build.date`

安卓安全补丁日期：`bd`

设备CPU架构为：`getprop ro.product.cpu.abi`

ROOT状态：`rt`

SELinux状态：`sl`

系统busybox位置：`bb`

系统toybox位置：`tb`

A/B设备：`ab`

分区架构类型：`fqjg`

super分区：`super`

默认屏幕dpi：`wm density | awk 'NR==1{print $NF}'`

当前屏幕dpi：`wm density | awk 'END{print $NF}'`

默认屏幕分辨率：`wm size | awk 'NR==1{print $NF}'`

当前屏幕分辨率：`wm size | awk 'END{print $NF}'`

屏幕宽高比：`wm size | awk -F 'x' 'NR==1{print $NF/120}'`:9

RAM内存：`free -b|awk '/^Mem/ {print $2/1000000}'`m

ROM储存规格：`rom_type`

`df -h /system | awk 'END{print "/system储存信息：总大小："$2"、已用："$3"、剩余："$4"、使用率："$5}'`

`df -h /data | awk 'END{print "内部储存信息：总大小："$2"、已用："$3"、剩余："$4"、使用率："$5}'`

当前电量：`Power`
"
if [[ -n $DL ]]; then
    echo "充电状态：正在充电"
else
    echo "充电状态：未充电"
fi

echo "
指纹：`fingerprint`

设备 id：`settings get secure android_id`

主板 id：`cat /sys/devices/soc0/serial_number 2>/dev/null || echo '未知'`

Boot id：`cat /proc/sys/kernel/random/boot_id`

已运行时间：`ykj`

内核信息：`cat /proc/version`

内核类型：`uname -s`

内核架构：`uname -m`

内核版本：`uname -r`

内核版本发布时间：`uname -v`
"

exit 0

CPU=`cat /proc/cpuinfo | grep SDM | sed 's/.*SDM//'`
echo -n "BL锁状态："
a=`getprop ro.boot.flash.locked`
b=`getprop ro.boot.verifiedbootstate`
    if [[ "$a" = 0 && "$b" = orange ]]; then
        echo "已解锁"
    elif [[ "$a" = 1 && "$b" = green ]]; then
        echo "未解锁"
    fi
屏幕密度：`getprop ro.sf.lcd_density`
