# 2023-03-01 18:29:38
export APK_Name_list2=$CONFIG_DIR/apk_name2.log
export APK_Name_list=$CONFIG_DIR/apk_name.log
export ASD=$SCRIPT/app_store-data.sh
export BOOTMODE=true
export Charging_control2=/sys/class/power_supply/battery/charging_enabled
export Charging_control=/sys/class/power_supply/battery/input_suspend
export Choice=false
export File Download_File
export Frame_Dir=/data/misc/$PACKAGE_NAME
export Game_Toolbox_File=/data/data/com.miui.securitycenter/files/gamebooster/freeformlist
export Install_Method=$SCRIPT/geek/installation_check.sh
export MWD=$SCRIPT/magisk_module/magisk_warehouse-data.sh
export SDdir=/data/media/$USER_ID
export Status=$CONFIG_DIR/status.log
export Termux=$USER_DIR/com.termux/files
export by_name="busybox sh $ENV_FILE $SCRIPT/block_device_name.sh"
export install_Frame="sh $ENV_FILE $SCRIPT/geek/install_frame_script.sh"
export install_MOD="sh $ENV_FILE $SCRIPT/magisk_module/install_module_script.sh"
export jian="$TMPDIR/update-binary"
export repo=$SCRIPT/repo_common.sh
export which="$ELF1_PATH/which"
export Time=`date '+%s'`
if [[ -f $CONFIG_DIR/GJZS_PATH ]]; then
    export GJZS=`cat $CONFIG_DIR/GJZS_PATH`
else
    export GJZS=$SD_DIR/$PACKAGE_NAME
fi
export lu=$GJZS/Batch_installation
export lu2=$GJZS/Add_Modules
export lu3=$GJZS/XianShua

if [[ -f $CONFIG_DIR/magisk-lite-modules_dir.log ]]; then
    export Modules_Dir=/data/adb/lite_modules
else
    export Modules_Dir=/data/adb/modules
fi


mask() {
. $SCRIPT/magisk_env.sh
[[ -z $Magisk ]] && abort "！当前Magisk状态：无法获取"

if [[ "$1" == "-vc" ]]; then
    if [[ -d $Modules_Dir ]]; then
        echo "已安装Magisk版本：$MAGISK_VER（$MAGISK_VER_CODE）"
        [[ $MAGISK_VER_CODE -lt 19000 ]] && abort "！未适配Magisk 19.0以下的版本，19.0以下版本采用magisk.img方式挂载模块"
        echo "---------------------------------------------------------"
        [[ `sh $SCRIPT/support/magisk_missing_file.sh` = 1 ]] && abort -e "已检测到Magisk需要修复运行环境\n缺失 Magisk 正常工作所需的文件，如果不修复您将无法使用模块功能，可在Magisk里修复也可以在Magisk专区--> 一键修复Magisk运行环境" || return 0
    fi
elif [[ "$1" == "-m" ]]; then
    [[ -z "$2" ]] && abort "！未设置模块id"
    id="$2"
    Module="$Modules_Dir/$2"
    Module_XinXi="$Module/module.prop"
    Module_S="$Module/post-fs-data.sh"
    Module_S2="$Module/service.sh"
    Module_us="$Module/uninstall.sh"
    Module_prop="$Module/system.prop"
    Module_Disable="$Module/disable"
    Module_Remove="$Module/remove"
    Module_Skip_Mount="$Module/skip_mount"
    Module_Update="$Module/update"
    if [[ -f $Module_XinXi ]]; then
        version0=`grep_prop version "$Module_XinXi"`
        versionCode0=`grep_prop versionCode "$Module_XinXi"`
    fi
fi
}

Start_Time() {
    Start_ns=`date +'%s%N'`
}

End_Time() {
    local ml=echo
    [[ "$1" = -t ]] && ml=toast && shift
    #小时、分钟、秒、毫秒、纳秒
    local h min s ms ns End_ns time
    End_ns=`date +'%s%N'`
    time=`echo "$End_ns-$Start_ns" | bc`
    [[ -z "$time" ]] && return 0
    s=`echo "$time/1000000000" | bc`
    ns=`echo "$time%1000000000" | bc`
    ms=`echo "scale=6; $ns/1000000" | bc`
        if [[ $s -ge 3600 ]]; then
            h=`echo "$s/3600" | bc`
            s=`echo "$s%3600" | bc`
            if [[ $s -ge 60 ]]; then
                min=`echo "$s/60" | bc`
                s=`echo "$s%60" | bc`
            fi
            $ml "- $* 用时：$h小时$min分钟$s秒$ms毫秒"
        elif [[ $s -ge 60 ]]; then
            min=`echo "$s/60" | bc`
            s=`echo "$s%60" | bc`
            $ml "- $* 用时：$min分钟$s秒$ms毫秒"
        elif [[ -n $s ]]; then
            $ml "- $* 用时：$s秒$ms毫秒"
        else
            $ml "- $* 用时：$ms毫秒"
        fi
}

Download() {
    $Choice || return 0
    if [[ "$#" -lt 3 ]]; then
        abort "！没有参数无法提供下载"
    fi

    local Options ID code
    Options="$1"
    ID="$2"
        case "$Options" in
            -url)
                shift
                Link="$ID"
            ;;
            *)
                abort "！暂不支持下载"
            ;;
        esac
        Download_File="$resources/$2"
        MD5=$3
        case $Options in
            -url)
                down -# -L -o "$Download_File" -md5 $MD5 "$Link"
                code=$?
            ;;
        esac
            [[ $code -ne 0 ]] && abort "！错误代码：$code"
}

Mount_Write() {
    GZai=$1
    Result=1
    echo "开始使用`which mount`挂载$2可读写$3"
    mount -o rw,remount $GZai
        if [[ -w /$2 ]]; then
            system=/system
            vendor=/vendor
            Result=0
            return 0
        elif [[ -w "$GZai" ]]; then
            Result=0
            if [[ "$GZai" = / ]]; then
                unset GZai
            elif [[ "$GZai" = $MAGISKTMP/.magisk/mirror/system_root ]]; then
                if [[ -w "$GZai/system" ]]; then
                    GZai="$GZai/system"
                    Result=0
                else
                    unset GZai
                    Result=1
                    return 1
                fi
            fi
            return 0
        fi
}

Check_Mount() {
    [[ "$Result" -eq 0 ]] && echo "挂载$1读写成功。"
    if [[ "$Result" -eq 1 ]]; then
        error "！您的`getprop ro.product.model`（Android `getprop ro.build.version.release`）设备未解锁system"
        echo -e "\n\n错误详情：\n"
        mount | grep -m 1 /system 1>&2
        abort
    fi
}

Mount_system() {
    Mount_Write /system system . 2>/dev/null
    local result=$?
    if [[ $result -eq 1 ]]; then
        if [[ -n $Magisk ]]; then
            Mount_Write $MAGISKTMP/.magisk/mirror/system system .. 2>/dev/null
            result=$?
            if [[ $result -eq 1 ]]; then
                Mount_Write $MAGISKTMP/.magisk/mirror/system_root system ... 2>/dev/null
                result=$?
            fi
        fi
    fi
    
    if [[ $result -eq 1 ]]; then
        Mount_Write / system .... 2>/dev/null
    fi

    export system=${GZai:-/system}
    export audio="$system/media/audio/ui"
    Check_Mount system
    
    Unload(){
        mount -o ro,remount "$GZai" &>/dev/null
        [[ -w "$GZai" ]] && busybox mount -o ro,remount "$GZai" &>/dev/null
        #umount -r $GZai
    }
}

Mount_vendor() {
    mask
    Mount_Write /vendor vendor . 2>/dev/null
    if [[ $? -eq 1 ]]; then
        Mount_Write $MAGISKTMP/.magisk/mirror/vendor vendor .. 2>/dev/null
        if [[ $? -eq 1 ]]; then
            Mount_Write / vendor ... 2>/dev/null
        fi
    fi
    export vendor=${GZai:-/vendor}
    Check_Mount vendor
    
    
    Unload_vendor(){
        mount -o ro,remount "$GZai" &>/dev/null
        [[ ! -w "$GZai" ]] && busybox mount -o ro,remount "$GZai" &>/dev/null
        #umount -r $GZai
    }
}

grep_prop() {
    if [[ -z "$2" ]]; then
        which getprop &>/dev/null && getprop "$1" || magisk resetprop "$1"
        return $?
    elif [[ -f "$2" ]]; then
        result=`sed -rn "s/^$1=//p" "$2" | head -n 1`
        [[ -z "$result" ]] && return 1
        echo "$result"
    else
        return 22
    fi
        return 0 
}

set_perm() {
    # set_perm dir-file own own mod con
    [[ ! -e "$1" ]] && error "$1 文件/目录不存在无法设置权限" && return 1
    chown $2:$3 "$1" || return 2
    chmod $4 "$1" || return 2
    CON=$5
    [[ -z $CON ]] && CON=u:object_r:system_file:s0
    chcon $CON "$1" || return 2
}

set_perm_recursive() {
    # set_perm_recursive dir own own dir_mod file_mod con
    [[ ! -d "$1" ]] && error "$1 目录不存在无法递归设置权限" && return 1
    local dir file
    find "$1" -type d 2>/dev/null | while read dir; do
        set_perm "$dir" $2 $3 $4 $6
    done
        find "$1" -type f -o -type l 2>/dev/null | while read file; do
            set_perm "$file" $2 $3 $5 $6
        done
}

set_perm2() {
    # set_perm dir-file mod
    [[ ! -e "$1" ]] && error "$1 文件/目录不存在无法设置权限" && return 1
    chown $APP_UID:$APP_UID "$1" || return 1
    chmod $2 "$1" || return 2
    [[ `id -u` != 0 ]] && return 5
    [[ -z $con ]] && con=`ls -Z "$ENV_FILE" | sed 's/ .*//'`
    [[ -z $con ]] && return 3
    chcon $con "$1" || return 4
}

set_perm_recursive2() {
    # set_perm_recursive dir dir_mod file_mod
    [[ ! -d "$1" ]] && error "$1 目录不存在无法递归设置权限" && return 1
    local dir file
    find "$1" -type d 2>/dev/null | while read dir; do
        set_perm2 "$dir" $2
    done
        find "$1" -type f 2>/dev/null | while read file; do
            set_perm2 "$file" $3
        done
}

Write_Record() {
    local system=${system%/*}
    local jian=$MODPATH/Write_Record.sh
        cd $MODPATH
        for c in `find system`; do
            [[ -d "$c" ]] && continue
            if [[ -f "$system/$c" ]]; then
                #Original_file
                echo "开始备份/$c源文件"
                dir=`dirname "$c"`
                mkdir -p "$MODPATH/Original_file/$dir"
                cp -arf "$system/$c" "$MODPATH/Original_file/$dir"
            else
                #Add_file
                echo "$system/$c文件属于新添加文件开始写入记录"
                echo "rm -f \$$c" >>$jian
            fi
        done
}

Inject_prop() {
    if [[ -f "$MODPATH/system.prop" ]]; then
        grep '^[^#]' "$MODPATH/system.prop" | while read i; do
            if ! grep -q ^"$i"$ "$system/build.prop"; then
                echo "$i" >>"$system/build.prop"
                echo "$i" >>"$MODPATH/build.prop"
        fi
        done
    fi
}

Delete_prop() {
    if [[ -f "$MODPATH/build.prop" ]]; then
        cat "$MODPATH/build.prop" | while read i; do
            sed -i "/"$i"/d" "$system/build.prop"
        done
    fi
}

End_installation() {
    lu="$MODPATH/system"
    Inject_prop
    case "$MODID" in
        riru_edxposed | riru_edxposed_sandhook)
            echo "- 已跳过模块启动脚本"
        ;;
        
        *)
            [[ -f "$MODPATH/service.sh" ]] && sh "$MODPATH/service.sh" &>/dev/null
            [[ -f "$MODPATH/post-fs-data.sh" ]] && sh "$MODPATH/post-fs-data.sh" &>/dev/null
        ;;
    esac
    [[ ! -d "$lu" ]] && ls "$MODPATH" >"$Status" && abort2 "\n！ "$MODNAME"安装失败"
    Write_Record
    cp -arf "$lu"/* "$system"
    [[ $? = 0 ]] && echo "- "$MODNAME"安装成功" && rm -rf "$lu" || abort "！$MODNAME安装失败"
    Unload
    if [[ -f "$MODPATH/module.prop" ]]; then
        echo "THE END"
        [[ "$Result" = 0 ]] && CQ
    else
        abort "！未在框架目录里找到module.prop"
    fi
}

set_Game_Toolbox() {
    am force-stop com.miui.securitycenter
    set_perm /data/data/com.miui.securitycenter/files/gamebooster system system 700
    set_perm "$Game_Toolbox_File" system system 444
    echo "将在下次启动游戏时立即生效，不需要重启手机哦 ⊙∀⊙"
}

Check_Riru() {
    No_Riru() {
        error "*********************************************************"
        error "！未安装Riru框架，安装失败$*"
        abort "*********************************************************"
    }
        if [[ ! -f "/data/misc/riru/api_version" && ! -f "/data/misc/riru/api_version.new" ]]; then
            No_Riru ！
        fi
}

Frame_installation_Check() {
    if [[ -d "$Modules_Dir/$MODID" ]]; then
        abort -e "！已检测到用Magisk模块方式安装了$MODID，无法再次安装\n模块安装目录：\"$Modules_Dir/$MODID\""
    fi
}

Power() {
    if [[ -f /sys/class/power_supply/battery/capacity ]]; then
        echo "`cat /sys/class/power_supply/battery/capacity`%"
    else
        echo "`dumpsys battery | awk '/level/{print $2}'`%"
    fi
}

module_prop() {
    echo "- 正在打印模块信息……"
    [[ -z $Module ]] && abort "！未提供模块id"
cat <<Han >$Module_XinXi
id=$id
name=$name
version=$version
versionCode=$versionCode
author=$author
description=$description
Han

    [[ -f $Module_XinXi ]] && echo "- 「$name」模块安装完成，将在重启后生效" || { rm.-rf $Module; abort "！$name模块安装失败"; }
    CQ
    exit 0
}

Clean_install() {
    [[ -z "$id" ]] && abort "！未设置id"
    mask -m $id
    mkch -n $Module
    echo "- 开始安装 $name-$version($versionCode)"
    echo "- 安装目录：$Module"
    echo "- 模块作者：$author"
    echo "- Powered by Magisk"
    abort() {
        rm -rf $Module
        error "$@"
        sleep 3
        exit 1
    }
}

rgjk() {
    am start -S $PACKAGE_NAME/han.gaojike.ui.activity.WarningActivity >/dev/null
}

Web() {
    am start -a android.intent.action.VIEW -d "$1" >/dev/null
}

mkdir() {
    umask 022
    `$which mkdir` "$@"
}

touch() {
    umask 022
    `$which touch` "$@"
}

mkch() {
    local remove=false
    case $1 in
        -r)
            remove=true; shift
        ;;
        
        -n)
            shift
            [[ "$1" = -r ]] && { remove=true; shift; }
            for i in "$@"; do
                $remove && rm -rf "$i"
                [[ ! -d "$i" ]] && mkdir -p "$i"
            done
            return $?
        ;;
    esac
    
    for i in "$@"; do
        $remove && rm -rf "$i"
        if [[ ! -d "$i" ]]; then
            mkdir -p "$i"
            set_perm2 "$i" 700
        fi
    done
    return $?
}

mktouch() {
    if [[ -d $1 ]]; then
        abort "！$1 是个目录"
    elif [[ -f $1 ]]; then
        return 2
    else
        local dir=`dirname $1`
        mkdir -p $dir
        [[ -z $2 ]] && touch "$1" || echo "$2" >"$1"
    fi
}

abort() {
    error "$@"
    sleep 3
    exit 1
}

abort2() {
    abort -e "$@\n\n错误代码：`cat $Status`"
}

show_progress() {
    [[ -n $2 ]] && echo "progress:[$1/$2]" || echo "progress:[$1/100]"
}

adb() (
    local ADB=`$which adb`
    if [[ $# -eq 0 ]]; then
        exec "$ADB"
    fi
    
    case "$1" in
        help | --help | kill-server | start-server | reconnect | devices | keygen | tcpip | connect | disconnect | usb | wait-for-*)
           exec "$ADB" "$@"
        ;;
        -reset)
            "$ADB" kill-server
            exec "$ADB" start-server
        ;;
    esac
    
    
    [[ -z `"$ADB" devices | egrep -vi 'List of.*'` ]] && error "！无设备连接" && exit 126
    exec "$ADB" "$@"
)

adb2() { 
    if [[ "$#" -eq 0 ]]; then
        adb.shell
        if [[ $? -ne 0 ]]; then
            abort "没有设备连接无法继续哦⊙∀⊙！"
        fi
    elif [[ "$1" = "-s" && "$#" -eq 2 ]]; then
        shift
        adb.shell < "$1"
    elif [[ "$1" = "-c" ]]; then
        shift
        adb.shell "$@"
    fi
}

adbsu() {
    local a b
    a=`adb.shell su --help | grep '\-c'`
    [[ -n "$a" ]] && b=true || b=false
        if [[ "$#" -eq 0 ]]; then
            adb.shell su
        elif [[ "$1" = "-s" && "$#" -eq 2 ]]; then
            shift
            adb.shell su < "$1"
        elif [[ "$1" = "-c" ]]; then
            shift
            $b && adb.shell su -c \'"$@"\' || echo "$@" | adb.shell su
        fi
}

fastboot() (
    local FASTBOOT=`$which fastboot`
    if [[ $# -eq 0 ]]; then
        exec "$FASTBOOT"
    fi
    
    case "$1" in
        help | --help | -h | devices)
        : ;;
        
        *)
            [[ -z `"$FASTBOOT" devices` ]] && error "！无设备连接" && exit 126
        ;;
    esac
    
    exec "$FASTBOOT" "$@"
)

show_versionCode() {
    local c
    c=`pm list packages --show-versioncode $1 | sed -n "s/.*$1 .*://p"`
    if [[ -z $c ]]; then c=`pm dump $1 | sed -n 's/.*versionCode=//p' | cut -f1 -d ' '`
        if [[ -z $c ]]; then c=`appinfo -o vc -pn $1`; return $?
        fi
    fi
    echo "$c"
}

show_versionName() {
    local vn
    vn=`pm dump $1 | grep -m 1 versionName | sed -n 's/.*=//p'`
    [[ -z $vn ]] && appinfo -o vn -pn $1 || echo "$vn"
}

state_get() {
    [[ `eval "$@"` = 1 ]] && echo true || echo false
}

state_set() {
    if $STATE; then
        eval "$@" 1
    else
        eval "$@" 0
    fi
}

install_zip() {
    [[ ! -f "$1" ]] && abort "！$1文件不存在"
    mkch -r $TMPDIR
    unzip -p "$1" 'META-INF/com/google/android/update-binary' &>$jian
    if [[ -s $jian ]]; then
        [[ `head -n 1 $jian` = '#!'* ]] && sed -i '1d' $jian
        chmod 755 $jian
        if [[ $# -eq 1 ]]; then
            $jian dummy 1 "$1"
        else
            $jian "$2" "$3" "$1" 
        fi
    else
        abort "！未找到：META-INF/com/google/android/update-binary"
    fi
}

Installing_Busybox() {
list="
sha256sum
tar
time
unzip
"

    local JCe JCe2
    JCe=$CONFIG_DIR/busybox_Installed.log
    [[ -f $JCe ]] && JCe2=`cat $JCe` || JCe2=0
    case "$ABI" in
        arm64*) Type=arm64-selinux;;
        arm*) Type=arm-selinux;;
        x86_64*) Type=x86_64-selinux;;
        x86*) Type=x86-selinux;;
        mips64*) Type=mips64;;
        mips*) Type=mips;;
        *) echo "！ 未知的架构 ${ABI}，无法安装busybox"; return 1;;
    esac
    
        . "$Load" Install_busybox
    Start_Install() {
        local name2="busybox-$Type版-$version（$versionCode）"
        echo "- 开始$1 $name2"
        mkch $ELF3_PATH $ELF4_PATH
        BusyBox2=$ELF4_PATH/busybox
        down -# -L -ri 1000 -o $BusyBox2 "$url"
        if [[ -f $BusyBox2 ]]; then
            set_perm2 $BusyBox2 700
            if "$BusyBox2" --install -s "$ELF4_PATH"; then
                echo "- $name2安装成功。"
                echo "$versionCode" >$JCe
                rm -rf $ELF3_PATH/*
                    for i in $list; do
                        $BusyBox2 ln -sf $BusyBox2 $ELF3_PATH/$i
                    done
            else
                echo "！$name2安装失败❌"
                echo "d2" >$JCe
                rm -f "$BusyBox2"
                sleep 3
            fi
        fi
    }
        if [[ $JCe2 = d2 ]]; then
            :
        elif [[ ! -L $ELF3_PATH/unzip ]]; then
            Start_Install 安装
        elif [[ "$JCe2" -lt "$versionCode" ]]; then
            Start_Install 更新
        fi
}

Install_Applet() {
    local JCe JCe2
    JCe="$CONFIG_DIR/Applet_Installed.log"
    [[ -f "$JCe" ]] && JCe2=`cat $JCe` || JCe2=0
    case "$ABI" in
        arm64*) Type=arm64;;
        x86*) Type=x86;;
        *) return;;
    esac
    
    Start_Install() {
        if [[ ! -f "$ELF2_PATH/keycheck" ]]; then
            echo "- 开始安装$name"
        elif [[ "$JCe2" != "$4" ]]; then
            echo "- 开始更新$name"
        else
            return 0
        fi
            mkch $ELF2_PATH
            echo "- 解压文件……"
            unzip2 -q -d "$ELF2_PATH" $resources/$3

                if [[ $? = 0 ]]; then
                    echo "$4" >$JCe
                    echo "- 设置权限……"
                    (PATH=$PATH0
                    mke2fs=`$which mke2fs`
                    [[ -n $mke2fs ]] && echo "exec $mke2fs \"\$@\"" >$ELF2_PATH/mke2fs)
                    if [[ -f $PREFIX/soft_link.sh ]]; then
                        sh $PREFIX/soft_link.sh
                        rm -f $PREFIX/soft_link.sh
                    fi
                    set_perm_recursive2 $PREFIX 700 700
                    echo "- $name安装成功。"
                    rm -f $Download_File
                fi
        }
        . $Load Install_Applet
}

Initializing_the_environment() {
    Installing_Busybox
    Install_Applet
    PATH="$PATH"
    mkch -n $lu $lu2 $lu3
    exit 0
}
