dir=~/resources/bootanimation_screen1/customize
jian=$dir/Configuration.log

which convert &>/dev/null && unset xz || xz=' suffix="bmp"'

page() {
eval beizhu='$beizhu'$i
cat <<Han
    {
        "All in one": {
            "meta": {
                "reload": true,
                "interruptible": false,
                "icon": "$dir/$i.png"
            },
            "title": "${beizhu:-替换$i.bmp图片}",
            "shell": ". ./install_bootanimation_screen1_brush_in.sh $i",
            "params": [
                {
                    "name": "beizhu",
                    "title": "备注",
                    "type": "EditText"
                },
                {
                    "name": "picture",
                    "title": "图片不能大于${bmp_max[$i]}b/字节，分辨率：${bmp_fbl[$i]}",
                    "desc": "可输入路径也可以使用文件选择器选择文件\n温馨提示：可用「MT管理器」长按目录或文件 -->点属性 -->点击目录即可复制目录绝对路径，长按目录或长按名称即可复制文件绝对路径",
                    "type": "file"
                }
            ]
        }
    },
Han
}


cat <<Han
[
    {
        "All in one": {
            "meta": {
                "autoExit": "true",
                "interruptible": false,
                "reload": true
            },
            "title": "生成配置",
            "desc": "生成配置并备份分区，请确定您当前第一屏为正常状态再生成配置，否则后果自负。\n注：此过程会很漫长，请耐心等待，生成一次后无需重复生成",
            "shell": ". ./install_bootanimation_screen1_format.sh",
            "locked-sh": ". ./install_bootanimation_screen1_block.sh -c",
            "params": [
                {
                    "name": "IMG",
                    "label": "选择分区：",
                    "type": "Spinner",
                    "options-sh": ". ./install_bootanimation_screen1_block.sh",
                    "required": true
                }
            ]
        }
    },
Han

if [[ ! -f $jian ]]; then
cat <<Han
    {
        "Texts": {
            "params": [
                {
                    "size": 36,
                    "color": "#FFFF0000",
                    "value": "请点击「生成配置」"
                }
            ]
        }
    }
]
Han
exit 1
fi

. $jian
IMG_Name=${IMG_Name%.*}

cat <<Han
    {
        "Run": {
            "meta": {
                "reload": true,
                "interruptible": false,
                "confirm": true
            },
            "title": "恢复$IMG_Name分区",
            "desc": "恢复当初解析配置时的$IMG_Name分区镜像文件，请确保您没有清除过「搞机客」数据",
            "shell": ". ./install_bootanimation_screen1_brush_in.sh -r"
        }
    },
    {
        "All in one": {
            "meta": {
                "interruptible": false
            },
            "title": "分解logo.img/splash.img",
            "desc": "分解logo.img/splash.img找出里面所有.bmp图片",
            "shell": ". ./install_bootanimation_screen1_format.sh -d",
            "params": [
                {
                    "name": "File",
                    "type": "file",
                    "required": true,
                    "title": "可输入img文件绝对路径，也可以使用文件选择器选择文件"
                },
                {
                    "name": "File_Dir",
                    "type": "folder",
                    "desc": "可输入图片输出到的目录绝对路径，也可以通过文件选择器长按选定目录，上面是默认路径，请自行根据需求更改目录，温馨提示：可用「MT管理器」长按目录或文件 -->点属性 -->点击目录即可复制目录绝对路径，长按目录或长按名称即可复制文件绝对路径",
                    "value-sh": "grep_prop File_Dir $CONFIG_DIR/Install_BootAnimation_Screen1_Format.log || echo $GJZS/Pictures"
                }
            ]
        }
    },
    {
        "All in one": {
            "meta": {
                "interruptible": false
            },
            "title": "提取$IMG_Name分区",
            "shell": "IMG=$IMG; . ./mirror_partition_extract.sh",
            "params": [
                {
                    "name": "Extract",
                    "type": "folder",
                    "required": true,
                    "title": "可输入要提取到的目录绝对路径，也可以使用文件选择器长按选择目录",
                    "desc": "温馨提示：可用「MT管理器」长按目录或文件 -->点属性 -->点击目录即可复制目录绝对路径，长按目录或长按名称即可复制文件绝对路径",
                    "value-sh": "grep_prop Extract $CONFIG_DIR/img_Extract_Dir.log || echo $GJZS/img_Extract"
                }
            ]
        }
    },
    {
        "Texts": {
            "params": [
                {
                    "value": "以下只是显示缩略图，需要查看大图请前往：$GJZS/customize_BootAnimation_Screen1"
                }
            ]
        }
    },
Han


for i in `seq $Picture`; do
    page
done

cat <<Han
    {
        "Texts": {
            "params": [
                {
                    "size": 44,
                    "color": "#FFFF0000",
                    "value": "免责申明："
                },
                {
                    "size": 28,
                    "color": "#FF9400D3",
                    "br": 1,
                    "value": "原理：解析16进制数据，找到所有bmp图片16进制数据，然后计算出偏移量、分辨率、bmp图片大小，最后生成配置数据导出所有图片。替换图片时再按照解析出来的配置数据进行回填。理论上很安全，但是我不敢保证百分百不出问题！"
                },
                {
                    "size": 28,
                    "color": "#FFFF0000",
                    "value": "一旦使用了本页任何功能，出现的一切后果与我无关！请自行承担风险"
                },
                {
                    "size": 24,
                    "color": "#FF9400D3",
                    "br": 1,
                    "value": "arm64设备可选择任意格式/分辨率图片"
                },
                {
                    "size": 24,
                    "color": "#FFFF0000",
                    "value": "（非arm64设备只可选择bmp图片且图片分辨率必须一致）"
                }
            ]
        }
    }
]
Han
