#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


abort() {
    error "$@"
    rm -rf $Dir
    sleep 3
    exit 1
}

unpack() {
    [[ -d $2 ]] && rm -rf $2
    mkdir -p $2
    cd $2
    CHROMEOS=false
    magiskboot unpack "$1" 2>&1
    case $? in
    0 ) ;;
        1 )
        abort "! Unsupported/Unknown image format"
    ;;
    
    2 )
        ui_print "- ChromeOS boot image detected"
        CHROMEOS=true
    ;;
    
    * )
        abort "! Unable to unpack boot image"
    ;;
    esac
        [[ ! -f ramdisk.cpio ]] && abort "！未找到ramdisk.cpio"
}

root() {
    if $Magisk; then
        File=$1
        GJZS=$tmp2
        [[ -d $tmp2 ]] && rm -rf $tmp2
        mkdir -p $tmp2
        patched=$GJZS/magisk_patched_$Time.img
        [[ -e $patched ]] && rm -rf $patched
        . $SCRIPT/multi_function.sh Magisk -patched
        rm -rf $2/new-boot.img
        mv -f "$patched" $2/new-boot.img

    fi
}

CQ2() {
    if $ChongQi2; then
        echo "即将重启到恢复模式，倒计时开始……"
        for i in $(seq 4 -1 1); do
            echo $i
            sleep 1
        done
        reboot recovery
    fi
}


[[ -z `which hexdump` ]] && abort "！未找到hexdump命令"
file=${imgfile:-$ramdisk}
Dir=$TMPDIR/boot
tmp_a=$Dir/boot_a
tmp_b=$Dir/boot_b
tmp1=$Dir/tmp1
tmp2=$Dir/tmp2
[[ -d $Dir ]] && rm -rf $Dir


[[ ! -f "$file" ]] && abort "！$file 文件不存在"
case "$file" in
*.img)
    echo "- 检测已选择的.cpio是否为img文件格式"
    hexdump -n 8 -e '/1 "%02X"' $file | egrep -q '^414E44524F494421$' || abort "！不是img文件格式"
    unpack "$file" $tmp1
    cpio=$tmp1/ramdisk.cpio
;;
*.cpio)
    echo "- 检测已选择的.cpio是否为ramdisk.cpio文件格式"
    hexdump -n 6 -e '/1 "%02X"' $file | egrep -q '^303730373031$' || abort "！不是cpio文件格式"
    cpio="$file"
;;

*)
    abort "！未知文件后缀：${file##*.}"
;;
esac

    echo "- 正在提取ramdisk中……"
    for a in $IMG; do
        name=`basename $a`
        [[ ! -L $a ]] && abort "！$name分区不存在"
        unpack "$a" $Dir/$name
    done
    
        for b in $IMG; do
            echo "- 开始重新打包boot"
            for c in $tmp_a $tmp_b; do
                if [[ -d $c ]]; then
                    cd $c
                    cp -f $cpio $c/ramdisk.cpio
                    magiskboot repack $b 2>&1
                    magiskboot cleanup &>/dev/null
                    root $c/new-boot.img $c
                    echo "- 刷入中……"
                    dd if=$c/new-boot.img of=$b
                fi
            done
        done
        rm -rf $Dir
        CQ2
